require 'pathname'

code = <<-CODE
# Generated by generate_tests.rb
require_relative '../lib/same_site_ua_checker'

describe SameSiteUaChecker do
  subject { SameSiteUaChecker.call(ua_string) }
CODE

def generate_test_case(line)
  matches = line.match(/(true|false)\t(.+)/)
  return '' if line == ''
  return "\n  # #{line}" unless matches

  <<-CODE

  context '#{matches[2]}' do
    let(:ua_string) { '#{matches[2]}' }
    it { should eq #{matches[1]} }
  end
  CODE
end

Dir[File.join(__dir__, '..', '..', '..', 'test-suite', '*')].each do |path|
  f = File.open(path)
  lines = f.readlines.map(&:strip)
  f.close
  set_name = Pathname.new(path).basename.to_s

  code += "\n  # Set name: #{set_name}"
  lines.each do |line|
    code += generate_test_case(line)
  end
end

code += "end\n"

File.open(File.join(__dir__, '..', 'spec', 'same_site_ua_checker_spec.rb'), 'w') { |f| f.puts(code) }
