class SameSiteUaChecker
  class RegexVersionAbstract
    def regex_version
      raise NotImplementedError
    end

    # @return [Version]
    def detect(string_to_check)
      version = Version.new
      matches = string_to_check.match(regex_version)

      return version unless matches

      groups_count = matches.size - 1

      version.major = matches[1].to_i
      version.minor = matches[2].to_i if groups_count >= 2
      version.build = matches[3].to_i if groups_count >= 3

      version
    end
  end
end
